Will Styler's Praat Script Collection
=========

This is a repository for Praat scripts written by and useful to [Will Styler](http://savethevowels.org/will/), designed to supplant the set of scripts originally offered with the [2011 Linguistic Institute's Praat Workshop](https://verbs.colorado.edu/LSA2011/workshops/WS16.html).  

It accompanies Will's open-source Praat Textbook ['Using Praat for Linguistic Research'](http://savethevowels.org/praat/).  Check there for more information on scripting or on Praat in general.

## Disclaimer!

These scripts, although in production use by the authors and others, still have a variety of bugs, quirks, and difficulties.  By using these scripts, you agree...

- That you understand that these scripts may not reliably produce camera-ready data, and that all results must be hand-checked for sanity's sake. Pasting data from this script straight into your dissertation without careful review is not wise, as neither Praat, the script, nor the author(s) of the script should be trusted implicitly.

- That you understand that these scripts are a work in progress, which are far from perfect (and will contain bugs).  Future versions will be released here, and should be used when released to ensure improved results, but you will not necessarily be notified about them.  

- That these scripts may break with future updates of Praat, and that I'm not required to repair them when that happens.

- That you understand that Will is not required or necessarily available to fix bugs which are encountered, nor to modify the script to your needs (although you're welcome to submit bug reports to will (at) savethevowels (dot) org, if needed) 

- That you will acknowledge the author(s) of the scripts if you use, modify, fork, or re-use the code in your future work.  

... and, most importantly:

- That neither Will Styler, nor the University of Colorado, nor the University of Michigan, nor anybody else sufficiently tolerant of crappy puns to associate with him, are responsible for the results obtained from the proper or improper usage of these scripts, and that the author(s) of the scripts are not responsible for notifying users in the event that a bug or other issue is found, even if said bug or issue has caused the script to produce errant results in the past.  

Thanks for using my scripts and we hope it works wonderfully for you!

## About the Scripts

Each file has ReadMe information either as commenting at the start of the script, or in a separate file in the folder.  

These scripts were written on a Mac, for a Mac. You may need to change your paths from /Users/... to c:\\ or whatever silly things Windows makes you do.

If you're just wanting to get started in scripting, start with [Demo Formant Script](https://github.com/stylerw/styler_praat_scripts/blob/master/demo_formant_script.praat).  It's well-commented, and designed to be easy to use and adapt for other purposes.

The rest of the scripts are custom built for a variety of different purposes.  Enjoy!

## Where's the Nasality Script?

It's [right here](https://github.com/stylerw/styler_praat_scripts/tree/master/nasality_automeasure), but you're going to want to read the README file before you do *anything* with it.  Nasality's a dangerous beast!
